package cn.com.qmth.export;

import java.io.File;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.Set;
import java.util.concurrent.atomic.AtomicInteger;

import org.apache.commons.io.FileUtils;
import org.apache.log4j.LogManager;
import org.apache.log4j.Logger;

import com.google.common.base.Joiner;

public class ExportByCourseCode {
	private static Logger logger = LogManager.getLogger(ExportByCourseCode.class);
	private static String notFoundDir = "D:\\not_find\\";
	private static AtomicInteger count=new AtomicInteger(0);	
	private static AtomicInteger fdcount=new AtomicInteger(0);
	private static AtomicInteger notfdcount=new AtomicInteger(0);
	
	private  static List<String> qdb = new ArrayList<>();
	private  static List<String> qzip = new ArrayList<>();
	private  static List<String> adb = new ArrayList<>();
	private  static List<String> azip = new ArrayList<>();
	private  static List<String> http = new ArrayList<>();
	private  static List<String> filepath = new ArrayList<>();
	private  static Set<String> noques = new HashSet<>();
	
	
	private  static Set<Long> invalidAnswerCode = new HashSet<>();
	@SuppressWarnings({ "rawtypes", "unchecked" })
	public static void main(String[] args) {
		logger.debug("导出开始");
		try {
			File excelFolder = new File(notFoundDir);
			if (excelFolder.exists()) {
				FileUtil.clearDirectory(notFoundDir);
			} else {
				excelFolder.mkdir();
			}
			MyProducer pro=new MyProducer();
			pro.startDispose(MyConsumer.class, 8, null);
			for(Consumer co:pro.getConsumers()) {
				qdb.addAll((List<String>)co.getResult().get("qdb"));
				qzip.addAll((List<String>)co.getResult().get("qzip"));
				adb.addAll((List<String>)co.getResult().get("adb"));
				azip.addAll((List<String>)co.getResult().get("azip"));
				http.addAll((List<String>)co.getResult().get("http"));
				filepath.addAll((List<String>)co.getResult().get("file"));
				noques.addAll((Set<String>)co.getResult().get("noques"));
				invalidAnswerCode.addAll((Set<Long>)co.getResult().get("invalidAnswerCode"));
			}
			logger.debug("===============================================小题数据库没有文件：" + qdb.size());
			if (qdb.size() > 0) {
				File file=new File(notFoundDir+"\\题干在数据库中找不到文件.txt");
				file.createNewFile();
				FileUtils.writeStringToFile(file, "questionid idnumber source", "utf-8", true);
				FileUtils.writeLines(file, qdb,true);
			}
			logger.debug("===============================================小题zip没有文件：" + qzip.size());
			if (qzip.size() > 0) {
				File file=new File(notFoundDir+"\\题干在zip中找不到文件.txt");
				file.createNewFile();
				FileUtils.writeStringToFile(file, "questionid idnumber source", "utf-8", true);
				FileUtils.writeLines(file, qzip,true);
			}
			logger.debug("===============================================答案数据库没有文件" + adb.size());
			if (adb.size() > 0) {
				File file=new File(notFoundDir+"\\答案在数据库中找不到文件.txt");
				file.createNewFile();
				FileUtils.writeStringToFile(file, "answerid idnumber source", "utf-8", true);
				FileUtils.writeLines(file, adb,true);
			}
			logger.debug("===============================================答案zip没有文件：" + azip.size());
			if (azip.size() > 0) {
				File file=new File(notFoundDir+"\\答案在zip中找不到文件.txt");
				file.createNewFile();
				FileUtils.writeStringToFile(file, "answerid idnumber source", "utf-8", true);
				FileUtils.writeLines(file, azip,true);
			}
			logger.debug("===============================================http连接数：" + http.size());
			if (http.size() > 0) {
				File file=new File(notFoundDir+"\\http连接.txt");
				file.createNewFile();
				FileUtils.writeLines(file, http,true);
			}
			logger.debug("===============================================file连接数：" + filepath.size());
			if (filepath.size() > 0) {
				File file=new File(notFoundDir+"\\file连接.txt");
				file.createNewFile();
				FileUtils.writeLines(file, filepath,true);
			}
			logger.debug("===============================================内容空白校验：" + invalidAnswerCode.size());
			if (invalidAnswerCode.size() > 0) {
				logger.debug(Joiner.on(",").join(invalidAnswerCode));
			}
			logger.debug("===============================================没有小题：" + noques.size());
			if (noques.size() > 0) {
				logger.debug(Joiner.on(",").join(noques));
			}
			logger.debug("===============================================找到：" + fdcount+" 未找到："+notfdcount);
		} catch (Exception e) {
			logger.error(e.getCause(), e);
		}
		logger.debug("导出结束");
	}

	public static void  addDisposeCount() {
		count.addAndGet(1);
		logger.debug("处理了"+count);
	}
	
	public static void addFd() {
		fdcount.addAndGet(1);
	}
	public static void addNotFd() {
		notfdcount.addAndGet(1);
	}
}
