package cn.com.qmth.export;

import java.io.File;
import java.io.IOException;
import java.util.HashSet;
import java.util.Map;
import java.util.Set;

import org.apache.log4j.LogManager;
import org.apache.log4j.Logger;
import org.apache.poi.openxml4j.exceptions.InvalidFormatException;
import org.apache.poi.xssf.usermodel.XSSFRow;
import org.apache.poi.xssf.usermodel.XSSFSheet;
import org.apache.poi.xssf.usermodel.XSSFWorkbook;


public class MyProducer extends Producer {
	private static Logger logger = LogManager.getLogger(MyProducer.class);
	private static String excelDir = "D:\\kd_export\\";

	@Override
	protected void produce(Map<String, Object> param) throws Exception {
		logger.info("***************************任务生产开始");
		File excelFolder = new File(excelDir);
		if (excelFolder.exists()) {
			FileUtil.clearDirectory(excelDir);
		} else {
			excelFolder.mkdir();
		}
		Set<String> codes = readCourseCode();
		if (codes == null || codes.size() == 0) {
			logger.debug("无数据导出");
			return;
		} else {
			logger.debug(codes.size() + "个课程");
		}
		for (String code : codes) {
			offer(code);
		}
		logger.info("***************************任务生产结束");
	}
	
	private  Set<String> readCourseCode() throws InvalidFormatException, IOException {
		File directory = new File("");
		Set<String> list = new HashSet<String>();
		XSSFWorkbook wb = null;
		try {
			wb = new XSSFWorkbook(directory.getAbsolutePath() + "\\course.xlsx");
			XSSFSheet sheet = wb.getSheetAt(0);
			int rows = sheet.getLastRowNum();
			for (int i = 1; i <= rows; i++) {
				XSSFRow row = sheet.getRow(i);
				String tem = row.getCell(0).getStringCellValue().trim();
				tem = tem.substring(0, tem.length() - 2);
				list.add(tem);
			}
		} finally {
			if (wb != null) {
				wb.close();
			}
		}
		return list;
	}
}
